"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Provider = Provider;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _State = _interopRequireDefault(require("./State"));

var _useProvider3 = _interopRequireDefault(require("./useProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 *
 * @param {Object} store with reducer, [initialState], and [middlewares]
 * @return {Node} a React Context Wrapper By State.Provider with dispatch and state
 */
function Provider(_ref) {
  var store = _ref.store,
      children = _ref.children;

  var _useProvider = (0, _useProvider3.default)(store),
      _useProvider2 = _slicedToArray(_useProvider, 3),
      state = _useProvider2[0],
      dispatch = _useProvider2[1],
      ready = _useProvider2[2];

  return _react.default.createElement(_State.default.Provider, {
    value: {
      dispatch: dispatch,
      state: state
    }
  }, ready ? children : null);
}

var _default = Provider;
exports.default = _default;