"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _State = _interopRequireDefault(require("./State"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**
 *
 * @param {Function} mapState takes the state and own props
 * @param {Function} mapDispatch takes dispatch and current props
 * @return {Node} A react component with additional props
 */
var connect = function connect() {
  var mapState = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
  var mapDispatch = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
  return function (ConnectedComponent) {
    return function (_ref) {
      var props = _extends({}, _ref);

      var _useContext = (0, _react.useContext)(_State.default),
          state = _useContext.state,
          dispatch = _useContext.dispatch;

      return _react.default.createElement(ConnectedComponent, _extends({}, props, mapState(state, props), mapDispatch(dispatch, props), {
        dispatch: dispatch
      }));
    };
  };
};

var _default = connect;
exports.default = _default;